{{/*
SPDX-FileCopyrightText: 2023 IG BvC (Interessengemeinschaft Betrieb von Containern)
SPDX-License-Identifier: Apache-2.0
*/}}
---
apiVersion: kyverno.io/v1
kind: ClusterPolicy
metadata:
  annotations:
    policies.kyverno.io/category: Best Practices
    policies.kyverno.io/description: "Service externalIPs can be used for a MITM attack
      (CVE-2020-8554). Restrict externalIPs or limit to a known set of addresses.
      See: https://github.com/kyverno/kyverno/issues/1367. This policy validates that
      the `externalIPs` field is not set on a Service.  \nThis Policy applies to all
      types of kind \"Service\", including ClusterIP and LoadBalancer."
    policies.kyverno.io/severity: medium
    policies.kyverno.io/subject: Service
    policies.kyverno.io/title: Restrict External IPs
    policies.opencode.de/ID: "501"
    policies.opencode.de/cve: 2020-8554
    policies.opencode.de/release-version: 0.0.3-alpha
  name: restrict-external-ips
spec:
  background: true
  rules:
  - match:
      resources:
        kinds:
        - Service
    name: check-ips
    validate:
      message: externalIPs are not allowed.
      pattern:
        spec:
          X(externalIPs): "null"
...
